using System;
using System.Collections.Generic;
using System.Text;
using System.Data;
using System.Data.SqlClient;
using System.Windows.Forms;

namespace AppKonekcije
{
    public class AppKonekcije
    {
        public SqlConnection konekcija;
        public String rutaBaze;
        public String nazivBaze;

        public AppKonekcije(String NazivBazeI_EXT)
        {
            //MessageBox.Show("UAO SAAAAMMM !!!");
            nazivBaze = NazivBazeI_EXT;
            rutaBaze = Application.StartupPath+ @"\"+NazivBazeI_EXT;
            //konekcija = new SqlConnection("server=.\\SQLEXPRESS;database=plate_akred.mdf;Trusted_Connection=yes");
            MessageBox.Show(rutaBaze);
            konekcija=new SqlConnection(@"Data Source=.\SQLEXPRESS;AttachDbFilename="+rutaBaze+";Integrated Security=True;Connect Timeout=30;User Instance=True");
        }
        public void konektujSe()
        {
            try
            {
                konekcija.Open();
            }
            catch (SqlException sqlEx)
            {
                //MessageBox.Show("sqlEx");
                MessageBox.Show(sqlEx.Message, "Greka", MessageBoxButtons.OK, MessageBoxIcon.Error);
            }
            
        }
        public void zatvoriKonekciju()
        {
            try
            {
                konekcija.Close();
            }
            catch (SqlException sqlExClose)
            {
                MessageBox.Show(sqlExClose.Message, "Greka", MessageBoxButtons.OK, MessageBoxIcon.Error);
            }
        }
        public DataSet ucitajPodatke(DataSet dsDestinacije, string komanda, SqlDataAdapter daPunjenjaDsDestinacije, string nazivTabele_u_DS_dest)
        {
            dsDestinacije = null;
            try
            {

                daPunjenjaDsDestinacije = new SqlDataAdapter(komanda,konekcija);

                dsDestinacije = new DataSet();
                daPunjenjaDsDestinacije.Fill(dsDestinacije, nazivTabele_u_DS_dest);
                return dsDestinacije;
            }
            catch (Exception)
            {
                return dsDestinacije;
            }
        }

        public int izbrojUnose(string imeTabeleKojojSeBrojeUnosi,SqlConnection konekcija)
        {
            //string naziv = ""; ;
            try
            {
                int ukupnoUnosa = 0;
                konektujSe();
                //pravi se selekt komanda
                string komandaBroja = "Select Count(*) FROM  " + imeTabeleKojojSeBrojeUnosi + "";
                //MessageBox.Show(komandaBroja);
                SqlCommand komanda = new SqlCommand(komandaBroja, konekcija);
                SqlDataReader reader = komanda.ExecuteReader();
                if (reader.HasRows)
                {   //Ukoliko reader ima neke redove
                    while (reader.Read())
                    {
                        ukupnoUnosa=Convert.ToInt32(reader.GetValue(0).ToString());
                        //ukupnoUnosa++;
                    }
                }
                reader.Close();
                zatvoriKonekciju();
                //MessageBox.Show(ukupnoUnosa.ToString());
                return ukupnoUnosa;

            }
            catch (Exception excep)
            {
                zatvoriKonekciju();
                MessageBox.Show(excep.Message);
                return 0;
            }
        }

        public void Brisi_prost_Unos(string kolonaKljuca,string kljucTabele,string nazivTabele)
        {
            //Pravi se DELETE komanda
            string CommStr = "Delete From "+nazivTabele+" Where "+kolonaKljuca+" LIKE '" +kljucTabele+ "'";
            //MessageBox.Show(CommStr);
            try
            {
                konektujSe();
                SqlCommand Comm = new SqlCommand(CommStr, konekcija);
                Comm.ExecuteNonQuery();
                MessageBox.Show("Uspeno ste izbrisali eljeni unos");

            }
            catch (Exception g)
            {
                MessageBox.Show(g.Message);
                MessageBox.Show("to znai da pokuavate da obriete iz tabele " +nazivTabele+ " celokupan unos pomou "+kolonaKljuca+", ali vam je zabranjeno brisanje jer se "+kolonaKljuca+" ,tj. podaci, nalaze u relaciji sa nekom drugom tabelom!");
            }
            finally
            {
                zatvoriKonekciju();
            }
        }


    }

}
