﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Data.SqlClient;
using System.IO;

namespace WindowsApplication1
{
    public partial class Form1 : Form
    {
        
        public String datum;
        public AppKonekcije.AppKonekcije konekcija=new AppKonekcije.AppKonekcije("plate_akred.mdf");
        public DataSet dstmpR;
        public int ID=0;
        public DataSet dsSudijeTmp;
        public String[] listaSudija;
        public String[] listaSudija2;
        public int idR,idR2 = 0;
        public string aktivanStampac;
        
        public Form1()
        {
            InitializeComponent();
            //fStampa = new Isplate.Stampa();
            datum = DateTime.Today.Day.ToString() + "." + DateTime.Today.Month.ToString() + "." + DateTime.Today.Year.ToString();

            
        }

        private void button2_Click(object sender, EventArgs e)
        {
            ID = 0;

            textBox3.Text ="";

            ID = izbrojUnose("Radnici");
            ID += 1;//

            textBox3.Text=ID.ToString();
            textBox1.Text="";
            textBox2.Text="";
        }

        /*private void monthCalendar1_DateChanged(object sender, DateRangeEventArgs e)
        {
            //datum = monthCalendar1.st.ToString();
            //MessageBox.Show(datum);
            datum = e.Start.ToShortDateString();
            MessageBox.Show(datum);
        }*/

        private void monthCalendar1_DateSelected(object sender, DateRangeEventArgs e)
        {
            datum = e.Start.ToShortDateString();
            //MessageBox.Show(datum);
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            ID = izbrojUnose("Radnici");
            ID += 1;
            textBox3.Text = ID.ToString();

            PopuniComboRadnici();
            comboBox1.DataSource = listaSudija;

            //resetuje stanje za stampu
            string zastampu1= "UPDATE Radnici SET zastampu = 0";
            string zastampuakred = "UPDATE Radnici SET zastampuakred = 0";

            SqlCommand Comm;
            try
            {
                konekcija.konektujSe();
                Comm = new SqlCommand(zastampu1, konekcija.konekcija);
                Comm.ExecuteNonQuery();
                Comm = new SqlCommand(zastampuakred, konekcija.konekcija);
                Comm.ExecuteNonQuery();

               // MessageBox.Show("Ažuriranje uspešno", "Informacija", MessageBoxButtons.OK, MessageBoxIcon.Information);
            }
            catch (Exception exc)
            {
                MessageBox.Show(exc.Message);
            }
            finally
            {
                konekcija.zatvoriKonekciju();

            }

            int brojko;
            string[] dokumenta;

            dokumenta = Directory.GetFiles(System.Windows.Forms.Application.StartupPath + @"\za_stampuakred", "*.doc");

            for (brojko = 0; brojko <= dokumenta.Length - 1; brojko++)
            {
                try
                {
                    File.Delete(dokumenta[brojko]);
                }
                catch (Exception ex)
                {
                    //MessageBox.Show(ex.Message);
                }

            }

        }
        public int izbrojUnose(String imeTabeleKojojSeBrojeUnosi)
        {
            //string naziv = ""; ;
            try
            {
                int ukupnoUnosa = 0;
                konekcija.konektujSe();
                //pravi se selekt komanda
                string komandaBroja = "Select Count(*) FROM  " + imeTabeleKojojSeBrojeUnosi + "";
                //MessageBox.Show(komandaBroja);
                SqlCommand komanda = new SqlCommand(komandaBroja, konekcija.konekcija);
                SqlDataReader reader = komanda.ExecuteReader();
                if (reader.HasRows)
                {   //Ukoliko reader ima neke redove
                    while (reader.Read())
                    {
                        ukupnoUnosa = Convert.ToInt32(reader.GetValue(0).ToString());
                        //ukupnoUnosa++;
                    }
                }
                reader.Close();
                konekcija.zatvoriKonekciju();
                //MessageBox.Show(ukupnoUnosa.ToString());
                return ukupnoUnosa;

            }
            catch (Exception excep)
            {
                konekcija.zatvoriKonekciju();
                MessageBox.Show(excep.Message);
                return 0;
            }
        }

        private void button1_Click(object sender, EventArgs e)
        {
            string strKomanda = "";
            SqlCommand komanda;

            if (textBox1.Text != "" & textBox2.Text != "")
            {
                try
                {
                    konekcija.konektujSe();

                    strKomanda = "INSERT INTO Radnici (id,ime,prezime) VALUES ('" + textBox3.Text + "','" + textBox1.Text + "','" + textBox2.Text + "')";

                    komanda = new SqlCommand(strKomanda, konekcija.konekcija);
                    komanda.ExecuteNonQuery();
                    MessageBox.Show("Radnik je uspešno dodat!");
                }
                catch (Exception exc)
                {
                    MessageBox.Show(exc.Message);
                }
                finally
                {
                    konekcija.zatvoriKonekciju();
                }

            }
            else
            {
                MessageBox.Show("Niste uneli puno ime radnika", "  Obaveštenje", MessageBoxButtons.OK, MessageBoxIcon.Warning);
            }
        }

        private void tabControl1_Selected(object sender, TabControlEventArgs e)
        {
            dstmpR = new DataSet();
            dstmpR = DajRadnike();

            if (tabControl1.SelectedIndex == 4)
            {
                textBox4.DataBindings.Clear();
                textBox4.Text = "";
                textBox4.DataBindings.Add(new Binding("Text", dstmpR,"Radnici.id"));

                textBox6.DataBindings.Clear();
                textBox6.Text = "";
                textBox6.DataBindings.Add(new Binding("Text", dstmpR, "Radnici.ime"));

                textBox5.DataBindings.Clear();
                textBox5.Text = "";
                textBox5.DataBindings.Add(new Binding("Text", dstmpR, "Radnici.prezime"));
            }
            else if (tabControl1.SelectedIndex == 0)
            {
                PopuniComboRadnici();
                comboBox1.DataSource = listaSudija;
            }
            else if (tabControl1.SelectedIndex == 1)
            {
                PopuniComboRadnici();
                comboBox2.DataSource = listaSudija;
                
            }
        }

        public DataSet DajRadnike()
        {
            DataSet dsRadnici = null;
            try
            {
                //pravi se selekt komanda
                string CommStr = "Select id AS id,ime AS ime, prezime AS prezime FROM Radnici";
                SqlDataAdapter daRadnici = new SqlDataAdapter(CommStr, konekcija.konekcija);

                dsRadnici = new DataSet();
                daRadnici.Fill(dsRadnici, "Radnici");
                return dsRadnici;
            }
            catch (Exception)
            {
                MessageBox.Show("Puklo u DajRadnike");
                return dsRadnici;
            }
        }

        private void button7_Click(object sender, EventArgs e)
        {
            this.BindingContext[dstmpR, "Radnici"].Position += 1;
        }

        private void button6_Click(object sender, EventArgs e)
        {
            this.BindingContext[dstmpR, "Radnici"].Position -= 1;
        }

        private void button5_Click(object sender, EventArgs e)
        {
            this.BindingContext[dstmpR, "Radnici"].Position = 0;
        }

        private void button8_Click(object sender, EventArgs e)
        {
            this.BindingContext[dstmpR, "Radnici"].Position =izbrojUnose("Radnici") -1;
        }

        private void button3_Click(object sender, EventArgs e)
        {
            Brisi_prost_Unos("id", textBox4.Text, "Radnici");
        }

        public void Brisi_prost_Unos(string kolonaKljuca, string kljucTabele, string nazivTabele)
        {
            //Pravi se DELETE komanda
            string CommStr = "Delete From " + nazivTabele + " Where " + kolonaKljuca + " LIKE '" + kljucTabele + "'";
            //MessageBox.Show(CommStr);
            try
            {
                konekcija.konektujSe();
                SqlCommand Comm = new SqlCommand(CommStr, konekcija.konekcija);
                Comm.ExecuteNonQuery();
                MessageBox.Show("Uspešno ste izbrisali željeni unos");

            }
            catch (Exception g)
            {
                MessageBox.Show(g.Message);
                MessageBox.Show("Što znaèi da pokušavate da obrišete iz tabele " + nazivTabele + " celokupan unos pomoæu " + kolonaKljuca + ", ali vam je zabranjeno brisanje jer se " + kolonaKljuca + " ,tj. podaci, nalaze u relaciji sa nekom drugom tabelom!");
            }
            finally
            {
                konekcija.zatvoriKonekciju();
            }
            dstmpR = new DataSet();
            dstmpR = DajRadnike();

            textBox4.DataBindings.Clear();
            textBox4.Text = "";
            textBox4.DataBindings.Add(new Binding("Text", dstmpR, "Radnici.id"));

            textBox6.DataBindings.Clear();
            textBox6.Text = "";
            textBox6.DataBindings.Add(new Binding("Text", dstmpR, "Radnici.ime"));

            textBox5.DataBindings.Clear();
            textBox5.Text = "";
            textBox5.DataBindings.Add(new Binding("Text", dstmpR, "Radnici.prezime"));

        }

        private void button4_Click(object sender, EventArgs e)
        {
            string komandaUpdateRadnika = "UPDATE Radnici SET ime='"+textBox6.Text+"',prezime='"+textBox5.Text+"' WHERE id=" + textBox4.Text;
            SqlCommand Comm;
            try
            {
                konekcija.konektujSe();
                Comm = new SqlCommand(komandaUpdateRadnika, konekcija.konekcija);
                Comm.ExecuteNonQuery();
                
                MessageBox.Show("Ažuriranje uspešno", "Informacija", MessageBoxButtons.OK, MessageBoxIcon.Information);
            }
            catch (Exception exc)
            {
                MessageBox.Show(exc.Message);
            }
            finally
            {
                konekcija.zatvoriKonekciju();

            }
        }
        public void PopuniComboRadnici()
        {
            //cmbSudija.DataSource = DajSudije().Tables["Imena_sudija"];
            //cmbSudija.DisplayMember = "Imena_sudija";
            //DataSet dsSudijeTmp = null;
            dsSudijeTmp = new DataSet();
            dsSudijeTmp = DajRadnike();

            int brojreda;
            listaSudija = new string[dsSudijeTmp.Tables["Radnici"].Rows.Count];
            String ime;
            String prezime;
            for (brojreda = 0; brojreda <= dsSudijeTmp.Tables["Radnici"].Rows.Count - 1; brojreda++)
            {
                ime = dsSudijeTmp.Tables["Radnici"].Rows[brojreda]["ime"].ToString();
                prezime = dsSudijeTmp.Tables["Radnici"].Rows[brojreda]["prezime"].ToString();
                listaSudija[brojreda] = ime + " " + prezime;
                ime = ""; prezime = "";
            }
            //MessageBox.Show(listaSudija[2]);
            
        }

        private void button9_Click(object sender, EventArgs e)
        {
            string komandaUpdateHonorari = "UPDATE Radnici SET obaveza='" + textBox7.Text + "',sumaH='" + textBox8.Text + "',zastampu=1 WHERE id=" + idR;

            SqlCommand Comm;
            try
            {
                konekcija.konektujSe();
                Comm = new SqlCommand(komandaUpdateHonorari, konekcija.konekcija);
                Comm.ExecuteNonQuery();
                
                MessageBox.Show("Ažuriranje uspešno", "Informacija", MessageBoxButtons.OK, MessageBoxIcon.Information);
            }
            catch (Exception exc)
            {
                MessageBox.Show(exc.Message);
            }
            finally
            {
                konekcija.zatvoriKonekciju();

            }
        }

        private void comboBox1_SelectedIndexChanged(object sender, EventArgs e)
        {
            idR = Convert.ToInt32(dsSudijeTmp.Tables["Radnici"].Rows[comboBox1.SelectedIndex]["id"]);
            //MessageBox.Show(idR.ToString());
        }

        private void button10_Click(object sender, EventArgs e)
        {
            textBox7.Text = "";
            textBox8.Text = "";
        }

        private void comboBox2_SelectedIndexChanged(object sender, EventArgs e)
        {
            idR2 = Convert.ToInt32(dsSudijeTmp.Tables["Radnici"].Rows[comboBox2.SelectedIndex]["id"]);
        }

        private void button14_Click(object sender, EventArgs e)
        {
            string komandaUpdateHonorari = "UPDATE Radnici SET suma='" + textBox9.Text + "',zastampuakred=1 WHERE id=" + idR2;

            SqlCommand Comm;
            try
            {
                konekcija.konektujSe();
                Comm = new SqlCommand(komandaUpdateHonorari, konekcija.konekcija);
                Comm.ExecuteNonQuery();

                MessageBox.Show("Ažuriranje uspešno", "Informacija", MessageBoxButtons.OK, MessageBoxIcon.Information);
            }
            catch (Exception exc)
            {
                MessageBox.Show(exc.Message);
            }
            finally
            {
                konekcija.zatvoriKonekciju();

            }
        }

        private void button13_Click(object sender, EventArgs e)
        {
            textBox9.Text = "";
        }

        private void button11_Click(object sender, EventArgs e)
        {
            /*Isplate.Stampa fStampa = new Isplate.Stampa();
            fStampa.Show();*/
            Isplate.GenerisanjeHonorara fGenHono = new Isplate.GenerisanjeHonorara(datum,aktivanStampac);
            fGenHono.ShowDialog();
            
        }

        private void button12_Click(object sender, EventArgs e)
        {
            Isplate.GenerisanjeH fGenHono = new Isplate.GenerisanjeH(datum, aktivanStampac);
            fGenHono.ShowDialog();
        }

        private void button15_Click(object sender, EventArgs e)
        {
            printDialog1.ShowDialog();
            aktivanStampac=printDialog1.PrinterSettings.PrinterName;
        }


     
                
    }
}