﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Data.SqlClient;
using System.IO;

namespace Isplate
{
    public partial class GenerisanjeH : Form
    {
        public AppKonekcije.AppKonekcije konekcija = new AppKonekcije.AppKonekcije("plate_akred.mdf");

        public DataSet dsRadTmp;
        public string date, stampacAktivan;
        public int sumaGenerisanih, check, poslednjiR;

        public GenerisanjeH(string datum, string stampac)
        {
            InitializeComponent();
            date = datum;
            stampacAktivan = stampac;
        }

        private void GenerisanjeH_Load(object sender, EventArgs e)
        {
            popuniChckListBox();
        }
        public void popuniChckListBox()
        {
            dsRadTmp = new DataSet();
            dsRadTmp = DajRadnikeHonorare();

            int brojreda;
            //
            //listaSudija = new string[dsSudijeTmp.Tables["Radnici"].Rows.Count];
            String ime, prezime;
            System.Object[] ItemObject = new System.Object[dsRadTmp.Tables["Radnici"].Rows.Count];

            for (brojreda = 0; brojreda <= dsRadTmp.Tables["Radnici"].Rows.Count - 1; brojreda++)
            {
                ime = dsRadTmp.Tables["Radnici"].Rows[brojreda]["ime"].ToString();
                prezime = dsRadTmp.Tables["Radnici"].Rows[brojreda]["prezime"].ToString();
                ItemObject[brojreda] = ime + " " + prezime;// +" " + suma;
                ime = ""; prezime = "";

            }
            //MessageBox.Show(ItemObject.ToString());
            checkedListBox1.Items.AddRange(ItemObject);
            for (brojreda = 0; brojreda <= dsRadTmp.Tables["Radnici"].Rows.Count - 1; brojreda++)
            {
                checkedListBox1.SetItemChecked(brojreda, true);
            }

            //checkedListBox1.SetItemChecked();
        }

        public DataSet DajRadnikeHonorare()
        {
            DataSet dsRadniciA = null;
            try
            {
                //pravi se selekt komanda
                string CommStr = "Select ime AS ime, prezime AS prezime,obaveza AS obaveza,sumaH AS sumaH FROM Radnici WHERE zastampu=1";
                SqlDataAdapter daRadniciA = new SqlDataAdapter(CommStr, konekcija.konekcija);

                dsRadniciA = new DataSet();
                daRadniciA.Fill(dsRadniciA, "Radnici");
                return dsRadniciA;
            }
            catch (Exception)
            {
                MessageBox.Show("Greška kod preuzimanja radnika - problem sa bazom");
                return dsRadniciA;
            }
        }

        
     

        public void GenerisiHonoWord()
        {
            //OBJECT OF MISSING "NULL VALUE"

            Object oMissing = System.Reflection.Missing.Value;

            //OBJECTS OF FALSE AND TRUE

            Object oTrue = true;

            Object oFalse = false;

            Object fileName = "";

            int br;
            check = 0;


            //CREATING OBJECTS OF WORD AND DOCUMENT

            Microsoft.Office.Interop.Word.Application oWord = new Microsoft.Office.Interop.Word.Application();

            Microsoft.Office.Interop.Word.Document oWordDoc = new Microsoft.Office.Interop.Word.Document();



            //MAKING THE APPLICATION VISIBLE

            oWord.Visible = checkBox1.Checked;

            for (br = 0; br <= checkedListBox1.Items.Count - 1; br++)
            {
                if (checkedListBox1.GetItemChecked(br))
                {
                    check += 1;
                    string sablon = System.Windows.Forms.Application.StartupPath + @"\sablon\sablonHonorari.doc";
                    //MessageBox.Show(sablon);
                    fileName = sablon;

                    oWordDoc = oWord.Documents.Open(ref fileName, ref oMissing, ref oMissing, ref oMissing, ref oMissing, ref oMissing, ref oMissing, ref oMissing, ref oMissing, ref oMissing, ref oMissing, ref oMissing, ref oMissing, ref oMissing, ref oMissing, ref oMissing);

                    oWordDoc.Activate();

                    //ime
                    
                                        //BOOK MARK FOR START OF SELECTION
                                        Object oBookmarkStart = "imeH";
                                        Object oRngoBookMarkStart = oWordDoc.Bookmarks.get_Item(ref oBookmarkStart).Range.Start;
                                        //BOOK MARK FOR END OF SELECTION
                                        Object oBookmarkEnd = "imeH_kraj";
                                        Object oRngoBookMarkEnd = oWordDoc.Bookmarks.get_Item(ref oBookmarkEnd).Range.Start;
                                        //SETTING THE RANGE ON THE BOOKMARK BETWEEN TWO BOOKMARKS
                                        Microsoft.Office.Interop.Word.Range rngBKMarkSelection = oWordDoc.Range(ref oRngoBookMarkStart, ref oRngoBookMarkEnd);
                                        //SELECTING THE TEXT
                                        rngBKMarkSelection.Select();
                                        rngBKMarkSelection.Delete(ref oMissing, ref oMissing);
                                        //Add text
                                        oWord.Selection.TypeText(dsRadTmp.Tables["Radnici"].Rows[br]["ime"].ToString() + " " + dsRadTmp.Tables["Radnici"].Rows[br]["prezime"].ToString());
                                        //oWord.Selection.TypeParagraph();

                                        //datum

                                        //BOOK MARK FOR START OF SELECTION
                                        oBookmarkStart = "obaveza";
                                        oRngoBookMarkStart = oWordDoc.Bookmarks.get_Item(ref oBookmarkStart).Range.Start;
                                        //BOOK MARK FOR END OF SELECTION
                                        oBookmarkEnd = "obaveza_kraj";
                                        oRngoBookMarkEnd = oWordDoc.Bookmarks.get_Item(ref oBookmarkEnd).Range.Start;
                                        //SETTING THE RANGE ON THE BOOKMARK BETWEEN TWO BOOKMARKS
                                        rngBKMarkSelection = oWordDoc.Range(ref oRngoBookMarkStart, ref oRngoBookMarkEnd);
                                        //SELECTING THE TEXT
                                        rngBKMarkSelection.Select();
                                        rngBKMarkSelection.Delete(ref oMissing, ref oMissing);
                                        //Add text
                                        oWord.Selection.TypeText(dsRadTmp.Tables["Radnici"].Rows[br]["obaveza"].ToString() );

                                        //suma

                                        //BOOK MARK FOR START OF SELECTION
                                        oBookmarkStart = "sumah";
                                        oRngoBookMarkStart = oWordDoc.Bookmarks.get_Item(ref oBookmarkStart).Range.Start;
                                        //BOOK MARK FOR END OF SELECTION
                                        oBookmarkEnd = "sumah_kraj";
                                        oRngoBookMarkEnd = oWordDoc.Bookmarks.get_Item(ref oBookmarkEnd).Range.Start;
                                        //SETTING THE RANGE ON THE BOOKMARK BETWEEN TWO BOOKMARKS
                                        rngBKMarkSelection = oWordDoc.Range(ref oRngoBookMarkStart, ref oRngoBookMarkEnd);
                                        //SELECTING THE TEXT
                                        rngBKMarkSelection.Select();
                                        rngBKMarkSelection.Delete(ref oMissing, ref oMissing);
                                        //Add text
                                        oWord.Selection.TypeText(dsRadTmp.Tables["Radnici"].Rows[br]["sumaH"].ToString());
                    
                    //THE LOCATION WHERE THE FILE NEEDS TO BE SAVED
                    string stampa = System.Windows.Forms.Application.StartupPath + @"\za_stampuhonorari\za_stampuH " + br + ".doc";
                    Object oSaveAsFile = (Object)stampa;
                    oWordDoc.SaveAs(ref oSaveAsFile, ref oMissing, ref oMissing, ref oMissing,
                        ref oMissing, ref oMissing, ref oMissing, ref oMissing, ref oMissing,
                        ref oMissing, ref oMissing, ref oMissing, ref oMissing, ref oMissing,
                        ref oMissing, ref oMissing);
                    //CLOSING THE FILE
                    oWordDoc.Close(ref oFalse, ref oMissing, ref oMissing);
                    //QUITTING THE APPLICATION
                    //oWord.Quit(ref oMissing, ref oMissing, ref oMissing);
                    //MessageBox.Show(dsRadTmp.Tables["Radnici"].Rows[br]["ime"].ToString());

                    System.Runtime.InteropServices.Marshal.ReleaseComObject(oWordDoc);

                    //System.Runtime.InteropServices.Marshal.ReleaseComObject(appWord);

                    oWordDoc = null;

                    //appWord = null;

                    GC.Collect();

                    sumaGenerisanih = br + 1;
                    this.label2.Text = "Ukupno je generisano: " + check + " honorara. Poslednji generisan honorar je za radnika :                                    " + dsRadTmp.Tables["Radnici"].Rows[br]["ime"].ToString() + " " + dsRadTmp.Tables["Radnici"].Rows[br]["prezime"].ToString();
                    this.label2.Update();
                    poslednjiR = br;
                }

            }
            oWord.Quit(ref oMissing, ref oMissing, ref oMissing);

            System.Runtime.InteropServices.Marshal.ReleaseComObject(oWord);
            oWord = null;
            GC.Collect();
            //MessageBox.Show(dsRadTmp.Tables["Radnici"].Rows[br]["ime"].ToString());
            this.label2.Text = "Broj generisanih honorara je: " + check;
        }

        private void button1_Click(object sender, EventArgs e)
        {
            checkBox1.Enabled = false;
            button1.Enabled = false;
            checkedListBox1.Enabled = false;
            GenerisiHonoWord();
            button2.Enabled = true;
        }

        private void button2_Click(object sender, EventArgs e)
        {
            button2.Enabled = false;
            checkBox2.Enabled = false;
            string[] dokumenti;
            //OBJECT OF MISSING "NULL VALUE"

            Object oMissing = System.Reflection.Missing.Value;
            Object varMissing = System.Reflection.Missing.Value;

            //OBJECTS OF FALSE AND TRUE

            Object oTrue = true;

            Object oFalse = false;

            Object fileName = "";

            int br;
            check = 0;


            //CREATING OBJECTS OF WORD AND DOCUMENT

            Microsoft.Office.Interop.Word.Application oWord = new Microsoft.Office.Interop.Word.Application();

            Microsoft.Office.Interop.Word.Document oWordDoc = new Microsoft.Office.Interop.Word.Document();

            oWord.Visible = checkBox2.Checked;

            oWord.ActivePrinter = stampacAktivan;
            //iz foldera gde se nalaze obrasci smesta putanje u listu
            dokumenti = Directory.GetFiles(System.Windows.Forms.Application.StartupPath + @"\za_stampuhonorari", "*.doc");
            int brojac, brStampe;

            //for petlja koja ima ciklusa koliko ima fajlova u folderu - prethodni

            for (brojac = 0; brojac <= dokumenti.Length - 1; brojac++)
            {
                try
                {
                    //otvara dokument iz liste i salje ga na stampu
                    fileName = dokumenti[brojac];

                    oWordDoc = oWord.Documents.Open(ref fileName, ref oMissing, ref oMissing, ref oMissing, ref oMissing, ref oMissing, ref oMissing, ref oMissing, ref oMissing, ref oMissing, ref oMissing, ref oMissing, ref oMissing, ref oMissing, ref oMissing, ref oMissing);

                    oWordDoc.Activate();

                    oWordDoc.PrintOut(ref oTrue, ref oFalse, ref varMissing, ref varMissing, ref varMissing, ref varMissing,
                        ref varMissing, ref varMissing, ref varMissing, ref varMissing, ref oFalse, ref varMissing, ref varMissing,
                        ref varMissing, ref varMissing, ref varMissing, ref varMissing, ref varMissing);

                    //CLOSING THE FILE
                    oWordDoc.Close(ref oFalse, ref oMissing, ref oMissing);

                    System.Runtime.InteropServices.Marshal.ReleaseComObject(oWordDoc);

                    oWordDoc = null;

                    GC.Collect();

                    brStampe = brojac + 1;
                    label2.Text = "Od ukupno " + dokumenti.Length.ToString() + " na štampu je poslato " + brStampe + " dokument-a";
                    label2.Update();

                }
                catch (Exception ex)
                {
                    MessageBox.Show(ex.Message);
                }

            }


            /*while (oWord.BackgroundPrintingStatus > 0)
            {
                //System.Threading.Thread.Sleep(250);
            }
            MessageBox.Show("Nema procesa u redu čekanja za štampač");
             * */

            //unistava resurse
            //QUITTING THE APPLICATION
            oWord.Quit(ref oMissing, ref oMissing, ref oMissing);
            System.Runtime.InteropServices.Marshal.ReleaseComObject(oWord);
            oWord = null;
            GC.Collect();


            //brise dokumente
            for (brojac = 0; brojac <= dokumenti.Length - 1; brojac++)
            {
                try
                {
                    File.Delete(dokumenti[brojac]);
                }
                catch (Exception ex)
                {
                    //MessageBox.Show(ex.Message);
                }

            }
            //dsRadTmp.Clear();
            //checkedListBox1.Items.Clear();

            string zastampu1 = "UPDATE Radnici SET zastampu = 0";
            //string zastampuakred = "UPDATE Radnici SET zastampuakred = 0";

            SqlCommand Comm;
            try
            {
                konekcija.konektujSe();
                Comm = new SqlCommand(zastampu1, konekcija.konekcija);
                Comm.ExecuteNonQuery();
                //Comm = new SqlCommand(zastampuakred, konekcija.konekcija);
                //Comm.ExecuteNonQuery();

                // MessageBox.Show("Ažuriranje uspešno", "Informacija", MessageBoxButtons.OK, MessageBoxIcon.Information);
            }
            catch (Exception exc)
            {
                MessageBox.Show(exc.Message);
            }
            finally
            {
                konekcija.zatvoriKonekciju();

            }
        }
    }
}